
struct REGVALUE
{
	REGVALUE *next;
	REGVALUE *older;
	void     *owner; // REGKEY*
	LPWSTR pwszName;
	DWORD  dwType;
	DWORD  nDataLen;
	LPVOID pData;
	BOOL   IsNew;
	// WCHAR name[]
	// WCHAR data[]
}

struct REGKEY
{
	REGKEY   *next;
	REGKEY   *childs;
	REGKEY   *parent;
	REGKEY   *deletedchilds;
	LPWSTR    pwszName;       // may be NULL for root keys
	REGVALUE *values;
	REGVALUE *deletedvalues;
	FILETIME  LastWriteTime;
	BOOL      IsNew;
	// WCHAR name[]
}
//#define SAVE_CHANGED_VALUES // REGVALUE.older
//#define SAVE_DELETED_VALUES // REGKEY.deletedvalues
//#define SAVE_DELETED_KEYS   // REGKEY.deletedchilds

class Unknown
{
	declare Unknown();
	declare virtual QueryInterface(REFIID *riid, void *ppvObject),HRESULT;
	declare virtual AddRef(),ULONG;
	declare virtual Release(),ULONG;
	int m_refcnt;
	QITAB *m_quitab; // not initialized in Unknown::Unknown()
}

class ClassFactory : Unknown
{
	declare ClassFactory();
	declare virtual CreateInstance(IUnknown *pUnkOuter, REFIID riid, void *ppvObject),HRESULT;
	declare virtual LockServer(BOOL fLock),HRESULT;
}

class CQueryContinue : Unknown
{
	declare CQueryContinue();
	declare virtual Release(),ULONG;
	declare virtual QueryContinue(),HRESULT;
	BOOL     *m_pRunning;
	IUnknown *m_commandtarget;
}

class OleCommandTarget : Unknown
{
	declare OleCommandTarget();
	declare virtual QueryStatus(GUID *pguidCmdGroup, ULONG cCmds, OLECMD *prgCmds, OLECMDTEXT *pCmdText),HRESULT;
	declare virtual Exec(GUID *pguidCmdGroup, DWORD nCmdID, DWORD nCmdExecOpt, VARIANT *pvaIn, VARIANT *pvaOut),HRESULT;
	// nCmdID=2: start, nCmdID=3: stop

	declare StartService();
	declare StopService();
	declare ThreadProc();
	declare HandleRegistryKeyChange(HKEY key, LPWSTR pwszKey, LPVOID pRegContext);
	declare HandleEventLogEvents();
	declare HandleEventLogEvent(EVENTLOGRECORD *pevlr);
	// helpers for event log
	declare GetBalloonIconForEvent(EVENTLOGRECORD *pevlr),DWORD;
	declare LoadModuleForEvent(LPWSTR pwszSource, HMODULE *ppv),BOOL;
	declare CreateArgumentsArray(EVENTLOGRECORD *pevlr),LPWSTR*;
	declare FreeArgumentsArray(EVENTLOGRECORD *pevlr, LPWSTR *arguments);

	HANDLE m_hThread;
	HANDLE m_hEventLog;
	HANDLE m_hExitEvent;
	HICON  m_hIcon;
	CQueryContinue *m_iqc;
	BOOL   m_fRunning;
}

extern _CLSID_EventLogNotifier as GUID;
